#ifndef MODEM_H
#define MODEM_H

#include <modem/lte_lc.h>
#include <zephyr/net/socket.h>
#include <zephyr/random/rand32.h>
#include <nrf_socket.h>
#include <zephyr/kernel.h>
#include <stdio.h>
#include <nrf_modem_at.h>
#include <modem/modem_info.h>

#define TCP_IP_HEADER_SIZE 28
#define TX_BUFFER_LEN   25

#define MSGTYPE_INVALID                 0
#define MSGTYPE_SURVEY_RESULT_UPLOAD    1 
#define MSGTYPE_ACK                     5
#define MSGTYPE_ACK_UPDATEREADY         6 

#define CONFIG_TCP_SERVER_ADDRESS_STATIC "2a05:d014:.............."
#define CONFIG_TCP_SERVER_PORT           7073

void modem_transmitData(void); 
void modem_server_transmission_work_fn(struct k_work *work);

void modem_main_init(void); 

void modem_lte_handler(const struct lte_lc_evt *const evt);

// Các hàm con for MODEM to Cellular network connection
void modem_modem_init(void);
int8_t modem_configure_low_power(void);
void modem_modem_connect(void);

// Các hàm con for TCP connection
int8_t modem_TCP_init(void);
void modem_server_disconnect(void);
void modem_server_disconnect_rx(void);
#endif